import 'package:interceptable/src/runtime/contract/filter.dart';
import 'package:interceptable/src/runtime/contract/target.dart';

class FilterChain {
  List<Filter> filters;

  bool isFirstExecution = true;

  FilterChain(this.filters);

  Object execute(Target target) {
    // remove last used value
    if (!this.isFirstExecution) {
      this.filters.removeAt(0);
    }

    if (this.filters.isEmpty) {
      return target.execute();
    }

    if (this.isFirstExecution) {
      this.isFirstExecution = false;
    }

    // start chaining
    return this.filters.first.execute(target, this);
  }
}
